/******************************************************
*
* copyright by H.G.Kleta, 2002, 2006
*
* if you wish to use these sources, please contact
*
* fhw at indigo2 dot de
*
******************************************************/

#include "callback.h"


/******************************************************
*
* void KeyCallback(unsigned char key, int x, int y)
*
* OpenGL key callback function
*
******************************************************/

void KeyCallback(unsigned char key, int x, int y)
{
/* handle key */
  switch ( key ) 
    {
/* realign scene */
      case SPC :
        resetScene = 1;
        transX     = 0.0;
        oldtransX  = transX;
        transY     = 0.0;
        oldtransY  = transY;
        transZ     = 10.0;
        oldtransZ  = transZ;
        rotX       = 0.0;
        rotY       = 0.0;
        break;/*SPC*/
/* flip scene */
      case f_Key : ;
      case F_Key :
        rotY       = rotY + 180.0;
        break;/*s,S*/
/* end program */
      case ESC :
        fprintf(stdout,GOOD_BYE);
        exit(OK);
/* ignore the rest  */
      default: ;
    }/*switch*/

/* trigger redisplay */
  glutPostRedisplay();
}/*keyCallback()*/


/******************************************************
*
* void MouseCallback(int button, int state, int x, int y)
*
* OpenGL mouse callback function
*
******************************************************/

void MouseCallback(int button, int state, int x, int y)
{
/* left mouse button */

  if(button == GLUT_LEFT_BUTTON)
    {
/* press left button */
      if(state == GLUT_DOWN && !leftButtonPressed)
        {
          leftButtonPressed = 1;
          if (!middleButtonPressed)
            {
              mouseXLeft = x;
              mouseYLeft = y;
            }/*if*/
/* press left while middle is pressed == release left */
          else
            {
              mouseZBoth = y;
              oldtransX = transX;
              oldtransY = transY;
            }/*else*/
        }/*if*/ 
      else
/* release left button */
      if(state == GLUT_UP && leftButtonPressed)
        {
          leftButtonPressed = 0;
/* release left while middle is pressed == press middle */
          if (middleButtonPressed)
            {
              oldtransZ = transZ;
              mouseXMiddle = x;
              mouseYMiddle = y;
            }/*if*/
        }/*if*/
    }/*if*/

/* middle button */

  if(button == GLUT_MIDDLE_BUTTON)
    {
/* press middle button */
      if(state == GLUT_DOWN && !middleButtonPressed)
        {
          middleButtonPressed = 1;
          if (!leftButtonPressed)
            {
              mouseXMiddle = x;
              mouseYMiddle = y;
            }/*if*/
/* press middle while left is pressed == release left */
          else
            {
              mouseZBoth = y;
            }/*else*/
        }/*if*/ 
      else
/* release middle button */
      if(state == GLUT_UP && middleButtonPressed)
        {
          middleButtonPressed = 0;
          if (!leftButtonPressed)
            {
              oldtransX = transX;
              oldtransY = transY;
            }/*if*/
/* release middle while left is pressed == press left */
          else
            {
              oldtransZ = transZ;
              mouseXLeft = x;
              mouseYLeft = y;
            }/*else*/
        }/*if*/
    }/*if*/

}/*MouseCallback()*/


/******************************************************
*
* void MoveCallback(int button, int state, int x, int y)
*
* OpenGL motion callback function
*
******************************************************/

void MoveCallback(int x, int y)
{
  if(leftButtonPressed)
    {
      if(!middleButtonPressed)
        {
/* x rotation */
          rotX = y-mouseYLeft;
          if(rotX > 360)
            rotX -= 360;
          if(rotX < 0)
            rotX += 360;
/* y rotation */
          rotY = x-mouseXLeft;
          if(rotY > 360)
            rotY -= 360;
          if(rotY < 0)
            rotY += 360;
/* reset values -> just use delta-angle */
          mouseXLeft = x;
          mouseYLeft = y;
        }/*if*/ 
      else
        {
          transZ = (mouseZBoth-y)/10.0+oldtransZ;
        }/*else*/
    }/*if*/
  if(middleButtonPressed && !leftButtonPressed)
    {
      transX = (x-mouseXMiddle)/10.0+oldtransX;
      transY = -(y-mouseYMiddle)/10.0+oldtransY;
    }/*if*/
/* trigger redisplay */
  glutPostRedisplay();

}/*MoveCallback()*/


/*****************************************************/

/* END OF FILE */
