/******************************************************
*
* copyright by H.G.Kleta, 2002, 2006
*
* if you wish to use these sources, please contact
*
* fhw at indigo2 dot de
*
******************************************************/

#ifndef __EDGE_LIST_H_
#define __EDGE_LIST_H_


/******************************************************
*
* includes, defines, typedefs
*
******************************************************/

#include <stdio.h>
#include <stdlib.h>

#include "mt_types.h"


/******************************************************
*
* EdgeListElement * CreateEdgeListElement(Edge *edge)
*
* function creates ListElement from edge and 
*          returns pointer to it
*
******************************************************/

EdgeListElement * CreateEdgeListElement(Edge *edge);


/******************************************************
*
* EdgeListElement * AddEdgeToListStart(Edge *edge, 
*                                      EdgeListElement *start)
*
* function adds edge to list (at the start) described by start
*
*          return value: start = pointer to start of list
*
******************************************************/

EdgeListElement * AddEdgeToListStart(Edge *edge,
                                     EdgeListElement *start);


/******************************************************
*
* EdgeListElement * AddEdgeToListEnd(Edge *edge,
*                                    EdgeListElement *start)
*
* function adds edge to list (at the end) described by start
*
*          return value: start = pointer to start of list
*
******************************************************/

EdgeListElement * AddEdgeToListEnd(Edge *edge,
                                   EdgeListElement *start);


/******************************************************
*
* EdgeListElement * RemoveEdgeListElement(EdgeListElement *element,
*                                         EdgeListElement *start)
*
* function removes element from List described by start
*          and returns pointer to start of list
*
******************************************************/

EdgeListElement * RemoveEdgeListElement(EdgeListElement *element,
                                        EdgeListElement *start);


/*****************************************************/

#endif /* __EDGE_LIST_H_ */

/* END_OF_FILE */
