/******************************************************
*
* copyright by H.G.Kleta, 2002, 2006
*
* if you wish to use these sources, please contact
*
* fhw at indigo2 dot de
*
******************************************************/

#ifndef __MT_TYPES_H_
#define __MT_TYPES_H_


/******************************************************
*
* defines, typedefs
*
******************************************************/

/* various ASCII Codes */
#define BS      8
#define ESC    27
#define SPC    32
#define f_Key 102
#define F_Key  70

/* Exit Codes */
#define OK           0
#define GL_ERROR     1
#define OPTION_ERROR 2
#define PARAM_ERROR  3
#define GOOD_BYE "\n\nThanks! You've made a little program very happy :-)\n\n"

/* for better readability coordinates */
#define X 0
#define Y 1
#define Z 2


/* vertices and vectors */
#define POINT_3D_SIZE  3
#define VECTOR_3D_SIZE 3

typedef float Coord;
typedef Coord Point3D[POINT_3D_SIZE];
typedef Coord Vector3D[VECTOR_3D_SIZE];


/* triangle, orientation of points is counterclockwise (viewed from top) */
typedef struct
{
  Point3D i;
  Point3D j;
  Point3D k;
} Triangle;

/* edge */
typedef struct
{
  int id;
  int age;
  Point3D i;
  Point3D j;
  Point3D k;
} Edge;



/* List element consists of Point, and two pointers         
   to next / previous element */
typedef struct PointListElement_
{
  Point3D point;
  struct PointListElement_ *next;
  struct PointListElement_ *previous;
} PointListElement;

/* List element consists of triangle, and two pointers
   to next / previous element */
typedef struct TriangleListElement_
{
  Triangle triangle;
  struct TriangleListElement_ *next;
  struct TriangleListElement_ *previous;
} TriangleListElement;

/* List element consists of edge,
   two pointers to next / previous element (for list) and 
   two pointers to left / right edge for local dependencies */
typedef struct EdgeListElement_
{
  Edge edge;
  struct EdgeListElement_ *next;
  struct EdgeListElement_ *previous;
  struct EdgeListElement_ *left;
  struct EdgeListElement_ *right;
} EdgeListElement;


/*****************************************************/

#endif /* __MT_TYPES_H_ */

/* END_OF_FILE */
