/******************************************************
*
* copyright by H.G.Kleta, 2002, 2006
*
* if you wish to use these sources, please contact
*
* fhw at indigo2 dot de
*
******************************************************/

#ifndef __POINT_LIST_H_
#define __POINT_LIST_H_


/******************************************************
*
* includes, defines, typedefs
*
******************************************************/

#include <stdio.h>
#include <stdlib.h>

#include "mt_types.h"


/******************************************************
*
* PointListElement * CreatePointListElement(Point3D p)
*
* function creates ListElement from point p and 
*          returns pointer to it
*
******************************************************/

PointListElement * CreatePointListElement(Point3D p);


/******************************************************
*
* PointListElement * AddPointToListStart(Point3D *p, 
*                                        PointListElement *start)
*
* function adds point p to list (at the start) described by start
*
*          return value: start = pointer to start of list
*
******************************************************/

PointListElement * AddPointToListStart(Point3D *p,
                                       PointListElement *start);


/******************************************************
*
* PointListElement * AddPointToListEnd(Point3D *p,
*                                      PointListElement *start)
*
* function adds point p to list (at the end) described by start
*
*          return value: start = pointer to start of list
*
******************************************************/

PointListElement * AddPointToListEnd(Point3D *p,
                                     PointListElement *start);


/******************************************************
*
* PointListElement * RemovePointListElement(PointListElement *element,
*                                           PointListElement *start)
*
* function removes element from List described by start
*          and returns pointer to start of list
*
******************************************************/

PointListElement * RemovePointListElement(PointListElement *element,
                                          PointListElement *start);


/*****************************************************/

#endif /* __POINT_LIST_H_ */

/* END_OF_FILE */
