/******************************************************
*
* copyright by H.G.Kleta, 2002, 2006
*
* if you wish to use these sources, please contact
*
* fhw at indigo2 dot de
*
******************************************************/

#ifndef __TRIANGLE_LIST_H_
#define __TRIANGLE_LIST_H_


/******************************************************
*
* includes, defines, typedefs
*
******************************************************/

#include <stdio.h>
#include <stdlib.h>

#include "mt_types.h"


/******************************************************
*
* TriangleListElement * CreateTriangleListElement(Triangle *triangle)
*
* function creates ListElement from triangle and 
*          returns pointer to it
*
******************************************************/

TriangleListElement * CreateTriangleListElement(Triangle *triangle);


/******************************************************
*
* TriangleListElement * AddTriangleToListStart(Triangle *triangle, 
*                                              TriangleListElement *start)
*
* function adds triangle to list (at the start) described by start
*
*          return value: start = pointer to start of list
*
******************************************************/

TriangleListElement * AddTriangleToListStart(Triangle *triangle,
                                             TriangleListElement *start);


/******************************************************
*
* TriangleListElement * AddTriangleToListEnd(Triangle *triangle,
*                                            TriangleListElement *start)
*
* function adds triangle to list (at the end) described by start
*
*          return value: start = pointer to start of list
*
******************************************************/

TriangleListElement * AddTriangleToListEnd(Triangle *triangle,
                                           TriangleListElement *start);


/******************************************************
*
* TriangleListElement * RemoveTriangleListElement(TriangleListElement *element,
*                                                 TriangleListElement *start)
*
* function removes element from List described by start
*          and returns pointer to start of list
*
******************************************************/

TriangleListElement * RemoveTriangleListElement(TriangleListElement *element,
                                                TriangleListElement *start);


/*****************************************************/

#endif /* __TRIANGLE_LIST_H_ */

/* END_OF_FILE */
